<?php
/**
*** @name gesa.conf.php
*** @description configuration file for libraries path
*** @author Quentin George <q.george@esia-sa.com>
*** @version 1.0.0
*** @date 19/04/2023
**/

define('WEB_ROOT', $_SERVER['DOCUMENT_ROOT']);
define('DEFAULT_LANG', 'fr');
// Path
define('MVCMODEL', WEB_ROOT . 'Model_gesa.php');
define('TPL_PATH', WEB_ROOT . 'templates/');
define('IMG_DIR', '/theme/default/images/');
define('CSS_MAIN', '/theme/default/css/design.css');
define('LIBS_DIR', '/libs/');
define('DATA_DIR', '/data/');
define('SHELL_SCRIPTS', './scripts/');
define('SN_FILE', '/etc/gesa/sn');
define('SERVER_URL_FILE', '/var/log/gesa_server_url');
define('USER_CONF_FILE', 'user.conf.json');
define('GESA_PLUGINS', '/usr/local/esia/plugins/');
define('NETWORK_CONF_FILE', 'network.conf.json');
define('GESA_UPDATES_INFO_FILE', '/home/esia/gesa_updates');
define('GESA_UPDATES_CRON_FILE', '/etc/cron.d/gesa_updates');
define('GESA_UPDATES_SCRIPT_FILE', '/home/esia/script_updates');
define('GESA_LOGS_FILE', '/home/esia/gesa.log');
define('PLUGINS_CONF_FILES_DIR', '/home/esia/');
define('DEFAULT_PROTOCOLS_CONF_FILES', array(
	'ssh' => 'main.ssh.conf',
	'powershell' => 'main.pwsh.conf',
	'ipmi' => 'main.ipmi.conf',
));
define('GESA_SSH_KEYS_DIR', WEB_ROOT . ltrim(DATA_DIR, '/') . 'ssh_keys/');
define('NET_CONF_SCRIPT_PATH', '/usr/local/gesa/netconfigure.php');
define('ECATP_CONF', array(
	'PATH' => '/etc/gesa/ecatp.conf',
	'LOG_INFO' => array(
		'SECTION' => 'LOG',
		'KEY' => 'info',
		'DEFAULT' => '/var/log/gesa_info.log',
	),
	'SERVER_URL' => array(
		'SECTION' => 'GESA',
		'KEY' => 'server_url',
		'DEFAULT' => '',
	),
));
// Libraries
define('LIB_SMARTY', WEB_ROOT . LIBS_DIR . 'smarty/Smarty.class.php');
define('USR_CLASS', WEB_ROOT . LIBS_DIR . 'esia/user.class.php');
define('GESA_CLASS', WEB_ROOT . LIBS_DIR . 'esia/GesaInterface.class.php');
define('LIB_GESA', WEB_ROOT . LIBS_DIR . 'esia/gesa.lib.php');
define('LIB_CONVERT', WEB_ROOT . LIBS_DIR . 'esia/convert.lib.php');
// Others
define('GESA_TYPES_BY_SN_TAG', array(
	'01' => array('type' => 'Unity', 'isVM' => FALSE),
	'86' => array('type' => 'Unity', 'isVM' => TRUE),
	'10' => array('type' => 'Egide Box', 'isVM' => FALSE),
	'90' => array('type' => 'Egide Box', 'isVM' => TRUE),
));
define('INFO_GESA_PROTOCOL', 'http://');
define('INFO_GESA_URL', 'infogesa.esia-sa.com');
define('DIAG_WEB_URL', 'https://ftp.debian.org');
define('REQUESTS_TIMEOUT', '2'); // In seconds
define('GESA_IFACES_TYPES', array('MGMT', 'Server', 'User', 'Guest', 'DMZ'));
define('PROTOCOLS_CONF_AVAILABLE', array(
	'ipmi' => array(
		'privileges' => array('USER', 'OPERATOR', 'ADMINISTRATOR'),
		'versions' => array('2' => 'LAN_2_0', '1.5' => 'LAN'),
	),
));

?>
