<?php
/**
*** @name interfaces.php
**/

$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path . 'common.php';

$smarty->assign('section', 'interfaces');

try
{
    if($action == '')
    {
        $gesa = Model_gesa::setGESANetworkCommon($gesa);
        $smarty->assign('gesa', $gesa->toArray());
        // Main mgmt interface which cannot be moved from interface
        $mainMgmt = array();
        $ifsArray = shell_exec('ip -a -j addr');
        if(!empty($ifsArray))
        {
            $ifsArray = json_decode($ifsArray, TRUE);
            // $ifsArray[0] is the loopback, $ifsArray[1] is the main mgmt
            $mainMgmt = array(
                'label' => 'MGMT',
                'type' => 'MGMT',
                'index' => $ifsArray[1]['ifindex'],
                'name' => $ifsArray[1]['ifname'],
                'mac' => $ifsArray[1]['address'],
                'ip_addr' => $gesa->getLocalIPaddress(),
                'netmask' => $ifsArray[1]['addr_info'][0]['prefixlen'], // Netmask as CIDR ['addr_info'][0] for ipv4
                'gateway' => $gesa->getGateway(),
                'dns' => implode(',', $gesa->getDNS()),
            );

            $ifacesConf = getJsonConfFile($path . DATA_DIR . NETWORK_CONF_FILE);
            if(!empty($ifacesConf['mgmt']))
            {
                $iface = $ifacesConf['mgmt'];
                if(empty($iface['vlan']))
                {
                    $iface['is_vlan'] = FALSE;
                }
                else
                {
                    $iface['is_vlan'] = TRUE;
                }
                $iface['dns'] = implode(',', $iface['dns']);
                $iface['is_dhcp'] = FALSE;
                if(!empty($iface['dhcp']))
                {
                    $iface['is_dhcp'] = TRUE;
                }

                $mainMgmt = array_merge($iface, $mainMgmt);
            }
        }
        $smarty->assign('index', 'mgmt');
        $smarty->assign('mainMgmt', $mainMgmt);

        // Tabs config
        $ifacesConf = array();
        $ifacesArr = getJsonConfFile($path . DATA_DIR . NETWORK_CONF_FILE);
        // If present inside conf file, delete main MGMT from tabs list because it's the default tab
        unset($ifacesArr['mgmt']);
        foreach($ifacesArr as $taggedIndex => $value)
        {
            // Convert dot into _ for html and js ids selection
            $taggedIndex = str_replace('.', '_', $taggedIndex);
            $ifacesConf[$value['label'] . $taggedIndex] = array('index' => $taggedIndex, 'label' => $value['label']);
            ksort($ifacesConf);
        }
        $smarty->assign('ifacesConf', $ifacesConf);

        // Check if there is availlable interfaces to allow creation
        $isIfaceAddable = FALSE;
        $ifsArray = shell_exec('ip -a -j addr');
        if(!empty($ifsArray))
        {
            $ifsArray = json_decode($ifsArray, TRUE);
            if(count($ifsArray) > 2)
            {
                // More than 2 ifaces because $ifsArray[0] is the loopback & $ifsArray[1] is the main mgmt interface and we prevent it's usage for anything else.
                $isIfaceAddable = TRUE;
            }
        }
        $smarty->assign('isIfaceAddable', $isIfaceAddable);
    }
    elseif($action == 'show')
    {
        // Get availlable interfaces
        $interfacesList = array();
        $ifsArray = shell_exec('ip -a -j addr');
        if(!empty($ifsArray))
        {
            $ifsArray = json_decode($ifsArray, TRUE);
            // Start at $i=2 because $ifsArray[0] is the loopback and we don't need it. $ifsArray[1] is the main mgmt interface and we prevent it's usage for anything else.
            for($i=2; $i < count($ifsArray); $i++)
            {
                $interfacesList[] = array(
                    'index' => $ifsArray[$i]['ifindex'],
                    'name' => $ifsArray[$i]['ifname'],
                    'mac' => $ifsArray[$i]['address'],
                );
            }
        }
        $smarty->assign('interfacesList', $interfacesList);

        // Get interfaces types list
        $smarty->assign('typesList', GESA_IFACES_TYPES);

        // Get selected interface conf
        $index = 0;
        $iface = array();
        if(!empty($_GET['index']))
        {
            $index = $_GET['index'];
            // Index in file contain . before vlan tag but in html it was converted into _
            $taggedIndex = str_replace('_', '.', $index);
           
            $ifacesConf = getJsonConfFile($path . DATA_DIR . NETWORK_CONF_FILE);
            if(!empty($ifacesConf[$taggedIndex]))
            {
                $iface = $ifacesConf[$taggedIndex];
                if(empty($iface['vlan']))
                {
                    $iface['is_vlan'] = FALSE;
                }
                else
                {
                    $iface['is_vlan'] = TRUE;
                }
                $iface['dns'] = implode(',', $iface['dns']);
                $iface['is_dhcp'] = FALSE;
                if(!empty($iface['dhcp']))
                {
                    $iface['is_dhcp'] = TRUE;
                }
            }
        }
        $smarty->assign('index', $index);
        $smarty->assign('iface', $iface);
    }
}
catch(GesaException | Exception $e)
{
	$errors[] = $e->getMessage();
}
$smarty->assign('errors', $errors);
$smarty->assign('action', $action);

$smarty->display(TPL_PATH . 'interfaces.html');
?>
